// bmp2vcmd.cpp

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct {
	int x;
	int y;
	int width;
	int height;
	char *label;
	char *dict;
	int dict_num;
} param_t;

int main(int argc, char *argv[]) {
	FILE *dfp = NULL;
	FILE *ifp = NULL;
	FILE *ofp = NULL;
	char *dictname;
	char *inname;
	char *outname;
	param_t param;
	char  head[64];
	char *src = NULL;
	char *dst = NULL;
	int *buf1 = NULL;
	int *buf2 = NULL;
	char *p1, *p2, *p3;
	int width, height;
	int pitch;
	int offset;
	int data;
	int cnt, num, pos, len;
	int i, j, w, h, r;

	if (argc < 9) {
		printf("Usage: %s <x> <y> <width> <height> <label> <chr-file> <bmp-file> <out-file>\n", argv[0]);
		return 1;
	}

	memset(&param, 0, sizeof(param_t));

	param.label  = new char[256];
	param.dict   = new char[16*4096];
	param.x      = strtol(argv[1], NULL, 0);
	param.y      = strtol(argv[2], NULL, 0);
	param.width  = strtol(argv[3], NULL, 0);
	param.height = strtol(argv[4], NULL, 0);
	strcpy(param.label, argv[5]);
	dictname = argv[6];
	inname   = argv[7];
	outname  = argv[8];

	if (param.width <= 0) {
		printf("(%d) ̎wɌ肪܂B\n", param.width);
		goto bye;
	}

	if (param.height <= 0) {
		printf("(%d) ̎wɌ肪܂B\n", param.height);
		goto bye;
	}

	dfp = fopen(dictname, "rb");
	if (dfp == NULL) {
		printf("%s ̃t@CI[vɎs܂B\n", dictname);
		goto bye;
	}

	ifp = fopen(inname, "rb");
	if (ifp == NULL) {
		printf("%s ̃t@CI[vɎs܂B\n", inname);
		goto bye;
	}

	ofp = fopen(outname, "w");
	if (ofp == NULL) {
		printf("%s ̃t@CI[vɎs܂B\n", outname);
		goto bye;
	}

	// CHRf[^̓ǂݍ
	r = fread(param.dict, sizeof(char), 16*4096, dfp);
	param.dict_num = r / 16;

	// wb_[̓ǂݍ
	fread(head, 54, sizeof(char), ifp);
	width   = (head[18] & 255);
	width  |= (head[19] & 255) <<  8;
	width  |= (head[20] & 255) << 16;
	width  |= (head[21] & 255) << 24;
	height  = (head[22] & 255);
	height |= (head[23] & 255) <<  8;
	height |= (head[24] & 255) << 16;
	height |= (head[25] & 255) << 24;
	pitch   = (width+3) & -4;

	// obt@̊m
	src = new char[pitch * 8];
	dst = new char[16];
	buf1 = new int[param.width/8];
	buf2 = new int[param.width/4];

	// f[^ϊ
	offset = 54+1024;
	offset += pitch * (height - param.y);
	for (h = 0; h < param.height-7; h += 8) {
		memset(buf1, 0, param.width/8*sizeof(int));
		offset -= pitch * 8;
		fseek(ifp, offset, SEEK_SET);
		fread(src, pitch*8, sizeof(char), ifp);
		p1 = src + pitch*8 + param.x;
		for (w = 0; w < param.width-7; w += 8) {
			p2 = p1;
			for (j = 0; j < 8; j++) {
				p2 -= pitch;
				data = 0;
				for (i = 0; i < 8; i++) {
					data |= ((0x00060500 >> (p2[i] & 3)) & 0x8080) >> i;
				}
				dst[j  ] = (char)(data     );
				dst[j+8] = (char)(data >> 8);
			}
			for (j = 0; j < param.dict_num; j++) {
				if (memcmp(&(param.dict[j*16]), dst, 16) == 0) {
					buf1[w/8] = j;
					break;
				}
			}
			p1 += 8;
		}
#if 1
		num = 0;
		cnt = 1;
		i = 1;
		while (i < param.width/8) {
			pos = 0;
			len = 0;
			for (j = 0; j < 7; j++) {
				r = i - (1<<j);
				if ((r >= 0) && (buf1[i] == buf1[r])) {
					for (w = 0; w < param.width/8-i; w++) {
						if (buf1[r+w] != buf1[i+w]) break;
					}
					if (w >= 2) {
						if (w > 32) w = 32;
						if (w > len) {
							pos = j+1;
							len = w;
						}
					}
				}
			}
			if (len > 0) {
				if (cnt > 0) {
					buf2[num] = cnt-1;
					memcpy(&buf2[num+1], &buf1[i-cnt], cnt*sizeof(int));
					num += 1 + cnt;
					cnt = 0;
				}
				buf2[num] = (pos<<5)|(len-1);
				num++;
				i += len;
			} else {
				cnt++;
				i++;
				if (cnt >= 32) {
					buf2[num] = cnt-1;
					memcpy(&buf2[num+1], &buf1[i-cnt], cnt*sizeof(int));
					num += 1 + cnt;
					cnt = 0;
				}
			}
		}
		if (cnt > 0) {
			buf2[num] = cnt-1;
			memcpy(&buf2[num+1], &buf1[i-cnt], cnt*sizeof(int));
			num += 1 + cnt;
		}
#else
		buf2[0] = 0x1f;
		memcpy(buf2+1, buf1, param.width/8*sizeof(int));
		num = param.width/8 + 1;
#endif

		fprintf(ofp, "%s_Data%d:", param.label, h/8);
		for (i = 0; i < num; i++) {
			if ((i & 7) == 0) {
				fprintf(ofp, "\n\t.db\t$%02x", buf2[i]);
			} else {
				fprintf(ofp, ",$%02x", buf2[i]);
			}
		}
		fprintf(ofp, "\n%s_Data%d_End:\n", param.label, h/8);
	}

bye:
	if (dfp) fclose(dfp);
	if (ifp) fclose(ifp);
	if (ofp) fclose(ofp);
	delete[] param.label;
	delete[] param.dict;
	delete[] src;
	delete[] dst;
	delete[] buf1;
	delete[] buf2;

	return 0;
}

